#include <GDIP.au3>
#include <GUIConstants.au3>
#include <Misc.au3>

Opt("GUIOnEventMode", 1)

$iGUIColorBG = 0xFFFFFFFF
$iGUIWidth = 400
$iGUIHeight = 400

$iX_Char = 50
$iY_Char = 50
$vX_Char = 0
$vY_Char = 0

$hWnd = GUICreate("Kollisionstest", $iGUIWidth, $iGUIHeight)
GUISetState()

_GDIPlus_Startup()

$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hWnd)
$hBitmap = _GDIPlus_BitmapCreateFromGraphics($iGUIWidth, $iGUIHeight, $hGraphic)
$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)
_GDIPlus_GraphicsSetSmoothingMode($hBuffer, 2)

$hPath = _GDIPlus_PathCreate()
_GDIPlus_PathAddRectangle($hPath, 100, 100, 25, 25)
_GDIPlus_PathAddEllipse($hPath, 250, 150, 200, 100)
Dim $aPoints[6][2]
$aPoints[0][0] = 5
$aPoints[1][0] = 125
$aPoints[1][1] = 125
$aPoints[2][0] = 150
$aPoints[2][1] = 125
$aPoints[3][0] = 135
$aPoints[3][1] = 150
$aPoints[4][0] = 200
$aPoints[4][1] = 210
$aPoints[5][0] = 100
$aPoints[5][1] = 300
_GDIPlus_PathAddCurve($hPath, $aPoints)
$hRegion = _GDIPlus_RegionCreateFromPath($hPath)

GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")

While Sleep(20)
	If _IsPressed("25") Then $vX_Char -= 0.2
	If _IsPressed("26") Then $vY_Char -= 0.2
	If _IsPressed("27") Then $vX_Char += 0.2
	If _IsPressed("28") Then $vY_Char += 0.2

	$iX_Char += $vX_Char
	$iY_Char += $vY_Char
	$vX_Char *= 0.98
	$vY_Char *= 0.98
	If _GDIPlus_RegionIsVisibleRect($hRegion, $iX_Char, $iY_Char, 20, 20, $hBuffer) Then
		$iX_Char -= $vX_Char
		$iY_Char -= $vY_Char
		$vX_Char = 0
		$vY_Char = 0
	EndIf
	_GDIPlus_GraphicsClear($hBuffer, $iGUIColorBG)
	_GDIPlus_GraphicsFillPath($hBuffer, $hPath)
	_GDIPlus_GraphicsFillRect($hBuffer, $iX_Char, $iY_Char, 20, 20)
	_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, $iGUIWidth, $iGUIHeight)
WEnd

Func _Exit()
	_GDIPlus_GraphicsDispose($hGraphic)
	_GDIPlus_GraphicsDispose($hBuffer)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_PathDispose($hPath)
	_GDIPlus_RegionDispose($hRegion)
	_GDIPlus_Shutdown()
	Exit
EndFunc